/**
 * @name array-of-arrays-into-ast
 * @fileoverview Turns an array of arrays of data into a nested tree of plain objects
 * @version 4.0.12
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/array-of-arrays-into-ast/}
 */

"use strict";var arrayOfArraysIntoAst=(()=>{var tt=Object.create;var M=Object.defineProperty,rt=Object.defineProperties,at=Object.getOwnPropertyDescriptor,ot=Object.getOwnPropertyDescriptors,ft=Object.getOwnPropertyNames,Z=Object.getOwnPropertySymbols,nt=Object.getPrototypeOf,ee=Object.prototype.hasOwnProperty,st=Object.prototype.propertyIsEnumerable;var Y=(e,t,a)=>t in e?M(e,t,{enumerable:!0,configurable:!0,writable:!0,value:a}):e[t]=a,h=(e,t)=>{for(var a in t||(t={}))ee.call(t,a)&&Y(e,a,t[a]);if(Z)for(var a of Z(t))st.call(t,a)&&Y(e,a,t[a]);return e},F=(e,t)=>rt(e,ot(t));var it=(e,t)=>()=>(t||e((t={exports:{}}).exports,t),t.exports),pt=(e,t)=>{for(var a in t)M(e,a,{get:t[a],enumerable:!0})},te=(e,t,a,r)=>{if(t&&typeof t=="object"||typeof t=="function")for(let n of ft(t))!ee.call(e,n)&&n!==a&&M(e,n,{get:()=>t[n],enumerable:!(r=at(t,n))||r.enumerable});return e};var ut=(e,t,a)=>(a=e!=null?tt(nt(e)):{},te(t||!e||!e.__esModule?M(a,"default",{value:e,enumerable:!0}):a,e)),lt=e=>te(M({},"__esModule",{value:!0}),e);var Je=it((Cf,_e)=>{"use strict";_e.exports=la;function I(e){return e instanceof Buffer?Buffer.from(e):new e.constructor(e.buffer.slice(),e.byteOffset,e.length)}function la(e){if(e=e||{},e.circles)return ma(e);return e.proto?r:a;function t(n,f){for(var o=Object.keys(n),s=new Array(o.length),u=0;u<o.length;u++){var l=o[u],c=n[l];typeof c!="object"||c===null?s[l]=c:c instanceof Date?s[l]=new Date(c):ArrayBuffer.isView(c)?s[l]=I(c):s[l]=f(c)}return s}function a(n){if(typeof n!="object"||n===null)return n;if(n instanceof Date)return new Date(n);if(Array.isArray(n))return t(n,a);if(n instanceof Map)return new Map(t(Array.from(n),a));if(n instanceof Set)return new Set(t(Array.from(n),a));var f={};for(var o in n)if(Object.hasOwnProperty.call(n,o)!==!1){var s=n[o];typeof s!="object"||s===null?f[o]=s:s instanceof Date?f[o]=new Date(s):s instanceof Map?f[o]=new Map(t(Array.from(s),a)):s instanceof Set?f[o]=new Set(t(Array.from(s),a)):ArrayBuffer.isView(s)?f[o]=I(s):f[o]=a(s)}return f}function r(n){if(typeof n!="object"||n===null)return n;if(n instanceof Date)return new Date(n);if(Array.isArray(n))return t(n,r);if(n instanceof Map)return new Map(t(Array.from(n),r));if(n instanceof Set)return new Set(t(Array.from(n),r));var f={};for(var o in n){var s=n[o];typeof s!="object"||s===null?f[o]=s:s instanceof Date?f[o]=new Date(s):s instanceof Map?f[o]=new Map(t(Array.from(s),r)):s instanceof Set?f[o]=new Set(t(Array.from(s),r)):ArrayBuffer.isView(s)?f[o]=I(s):f[o]=r(s)}return f}}function ma(e){var t=[],a=[];return e.proto?f:n;function r(o,s){for(var u=Object.keys(o),l=new Array(u.length),c=0;c<u.length;c++){var m=u[c],i=o[m];if(typeof i!="object"||i===null)l[m]=i;else if(i instanceof Date)l[m]=new Date(i);else if(ArrayBuffer.isView(i))l[m]=I(i);else{var x=t.indexOf(i);x!==-1?l[m]=a[x]:l[m]=s(i)}}return l}function n(o){if(typeof o!="object"||o===null)return o;if(o instanceof Date)return new Date(o);if(Array.isArray(o))return r(o,n);if(o instanceof Map)return new Map(r(Array.from(o),n));if(o instanceof Set)return new Set(r(Array.from(o),n));var s={};t.push(o),a.push(s);for(var u in o)if(Object.hasOwnProperty.call(o,u)!==!1){var l=o[u];if(typeof l!="object"||l===null)s[u]=l;else if(l instanceof Date)s[u]=new Date(l);else if(l instanceof Map)s[u]=new Map(r(Array.from(l),n));else if(l instanceof Set)s[u]=new Set(r(Array.from(l),n));else if(ArrayBuffer.isView(l))s[u]=I(l);else{var c=t.indexOf(l);c!==-1?s[u]=a[c]:s[u]=n(l)}}return t.pop(),a.pop(),s}function f(o){if(typeof o!="object"||o===null)return o;if(o instanceof Date)return new Date(o);if(Array.isArray(o))return r(o,f);if(o instanceof Map)return new Map(r(Array.from(o),f));if(o instanceof Set)return new Set(r(Array.from(o),f));var s={};t.push(o),a.push(s);for(var u in o){var l=o[u];if(typeof l!="object"||l===null)s[u]=l;else if(l instanceof Date)s[u]=new Date(l);else if(l instanceof Map)s[u]=new Map(r(Array.from(l),f));else if(l instanceof Set)s[u]=new Set(r(Array.from(l),f));else if(ArrayBuffer.isView(l))s[u]=I(l);else{var c=t.indexOf(l);c!==-1?s[u]=a[c]:s[u]=f(l)}}return t.pop(),a.pop(),s}}});var va={};pt(va,{defaults:()=>et,generateAst:()=>ja,version:()=>ha});var mt=typeof global=="object"&&global&&global.Object===Object&&global,N=mt;var dt=typeof self=="object"&&self&&self.Object===Object&&self,ct=N||dt||Function("return this")(),T=ct;var yt=T.Symbol,S=yt;var re=Object.prototype,xt=re.hasOwnProperty,bt=re.toString,B=S?S.toStringTag:void 0;function gt(e){var t=xt.call(e,B),a=e[B];try{e[B]=void 0;var r=!0}catch(f){}var n=bt.call(e);return r&&(t?e[B]=a:delete e[B]),n}var ae=gt;var ht=Object.prototype,At=ht.toString;function jt(e){return At.call(e)}var oe=jt;var vt="[object Null]",Ot="[object Undefined]",fe=S?S.toStringTag:void 0;function wt(e){return e==null?e===void 0?Ot:vt:fe&&fe in Object(e)?ae(e):oe(e)}var A=wt;function Tt(e){return e!=null&&typeof e=="object"}var j=Tt;var St="[object Symbol]";function kt(e){return typeof e=="symbol"||j(e)&&A(e)==St}var ne=kt;function Et(e,t){for(var a=-1,r=e==null?0:e.length,n=Array(r);++a<r;)n[a]=t(e[a],a,e);return n}var se=Et;var It=Array.isArray,L=It;var Mt=/\s/;function Bt(e){for(var t=e.length;t--&&Mt.test(e.charAt(t)););return t}var ie=Bt;var Dt=/^\s+/;function $t(e){return e&&e.slice(0,ie(e)+1).replace(Dt,"")}var pe=$t;function Ct(e){var t=typeof e;return e!=null&&(t=="object"||t=="function")}var D=Ct;var ue=0/0,Pt=/^[-+]0x[0-9a-f]+$/i,Ft=/^0b[01]+$/i,Nt=/^0o[0-7]+$/i,Lt=parseInt;function Rt(e){if(typeof e=="number")return e;if(ne(e))return ue;if(D(e)){var t=typeof e.valueOf=="function"?e.valueOf():e;e=D(t)?t+"":t}if(typeof e!="string")return e===0?e:+e;e=pe(e);var a=Ft.test(e);return a||Nt.test(e)?Lt(e.slice(2),a?2:8):Pt.test(e)?ue:+e}var le=Rt;var me=1/0,Wt=17976931348623157e292;function Kt(e){if(!e)return e===0?e:0;if(e=le(e),e===me||e===-me){var t=e<0?-1:1;return t*Wt}return e===e?e:0}var de=Kt;function Vt(e){var t=de(e),a=t%1;return t===t?a?t-a:t:0}var ce=Vt;var Ut="[object AsyncFunction]",Gt="[object Function]",qt="[object GeneratorFunction]",zt="[object Proxy]";function _t(e){if(!D(e))return!1;var t=A(e);return t==Gt||t==qt||t==Ut||t==zt}var ye=_t;function Jt(e,t,a,r){for(var n=e.length,f=a+(r?1:-1);r?f--:++f<n;)if(t(e[f],f,e))return f;return-1}var xe=Jt;function Qt(e){return e!==e}var be=Qt;function Ht(e,t,a){for(var r=a-1,n=e.length;++r<n;)if(e[r]===t)return r;return-1}var ge=Ht;function Xt(e,t,a){return t===t?ge(e,t,a):xe(e,be,a)}var he=Xt;var Zt=9007199254740991,Yt=/^(?:0|[1-9]\d*)$/;function er(e,t){var a=typeof e;return t=t==null?Zt:t,!!t&&(a=="number"||a!="symbol"&&Yt.test(e))&&e>-1&&e%1==0&&e<t}var Ae=er;var tr=9007199254740991;function rr(e){return typeof e=="number"&&e>-1&&e%1==0&&e<=tr}var R=rr;function ar(e){return e!=null&&R(e.length)&&!ye(e)}var W=ar;var or=Object.prototype;function fr(e){var t=e&&e.constructor,a=typeof t=="function"&&t.prototype||or;return e===a}var je=fr;function nr(e,t){for(var a=-1,r=Array(e);++a<e;)r[a]=t(a);return r}var ve=nr;var sr="[object Arguments]";function ir(e){return j(e)&&A(e)==sr}var q=ir;var Oe=Object.prototype,pr=Oe.hasOwnProperty,ur=Oe.propertyIsEnumerable,lr=q(function(){return arguments}())?q:function(e){return j(e)&&pr.call(e,"callee")&&!ur.call(e,"callee")},we=lr;function mr(){return!1}var Te=mr;var Ee=typeof exports=="object"&&exports&&!exports.nodeType&&exports,Se=Ee&&typeof module=="object"&&module&&!module.nodeType&&module,dr=Se&&Se.exports===Ee,ke=dr?T.Buffer:void 0,cr=ke?ke.isBuffer:void 0,yr=cr||Te,Ie=yr;var xr="[object Arguments]",br="[object Array]",gr="[object Boolean]",hr="[object Date]",Ar="[object Error]",jr="[object Function]",vr="[object Map]",Or="[object Number]",wr="[object Object]",Tr="[object RegExp]",Sr="[object Set]",kr="[object String]",Er="[object WeakMap]",Ir="[object ArrayBuffer]",Mr="[object DataView]",Br="[object Float32Array]",Dr="[object Float64Array]",$r="[object Int8Array]",Cr="[object Int16Array]",Pr="[object Int32Array]",Fr="[object Uint8Array]",Nr="[object Uint8ClampedArray]",Lr="[object Uint16Array]",Rr="[object Uint32Array]",y={};y[Br]=y[Dr]=y[$r]=y[Cr]=y[Pr]=y[Fr]=y[Nr]=y[Lr]=y[Rr]=!0;y[xr]=y[br]=y[Ir]=y[gr]=y[Mr]=y[hr]=y[Ar]=y[jr]=y[vr]=y[Or]=y[wr]=y[Tr]=y[Sr]=y[kr]=y[Er]=!1;function Wr(e){return j(e)&&R(e.length)&&!!y[A(e)]}var Me=Wr;function Kr(e){return function(t){return e(t)}}var K=Kr;var Be=typeof exports=="object"&&exports&&!exports.nodeType&&exports,$=Be&&typeof module=="object"&&module&&!module.nodeType&&module,Vr=$&&$.exports===Be,z=Vr&&N.process,Ur=function(){try{var e=$&&$.require&&$.require("util").types;return e||z&&z.binding&&z.binding("util")}catch(t){}}(),k=Ur;var De=k&&k.isTypedArray,Gr=De?K(De):Me,$e=Gr;var qr=Object.prototype,zr=qr.hasOwnProperty;function _r(e,t){var a=L(e),r=!a&&we(e),n=!a&&!r&&Ie(e),f=!a&&!r&&!n&&$e(e),o=a||r||n||f,s=o?ve(e.length,String):[],u=s.length;for(var l in e)(t||zr.call(e,l))&&!(o&&(l=="length"||n&&(l=="offset"||l=="parent")||f&&(l=="buffer"||l=="byteLength"||l=="byteOffset")||Ae(l,u)))&&s.push(l);return s}var Ce=_r;function Jr(e,t){return function(a){return e(t(a))}}var Pe=Jr;var Qr=Pe(Object.keys,Object),Fe=Qr;var Hr=Object.prototype,Xr=Hr.hasOwnProperty;function Zr(e){if(!je(e))return Fe(e);var t=[];for(var a in Object(e))Xr.call(e,a)&&a!="constructor"&&t.push(a);return t}var Ne=Zr;function Yr(e){return W(e)?Ce(e):Ne(e)}var Le=Yr;var ea="[object String]";function ta(e){return typeof e=="string"||!L(e)&&j(e)&&A(e)==ea}var Re=ta;function ra(e,t){return se(t,function(a){return e[a]})}var We=ra;function aa(e){return e==null?[]:We(e,Le(e))}var Ke=aa;var oa=Math.max;function fa(e,t,a,r){e=W(e)?e:Ke(e),a=a&&!r?ce(a):0;var n=e.length;return a<0&&(a=oa(n+a,0)),Re(e)?a<=n&&e.indexOf(t,a)>-1:!!n&&he(e,t,a)>-1}var _=fa;var na="[object Date]";function sa(e){return j(e)&&A(e)==na}var Ve=sa;var Ue=k&&k.isDate,ia=Ue?K(Ue):Ve,E=ia;var pa=T.isFinite;function ua(e){return typeof e=="number"&&pa(e)}var V=ua;function g(e){if(e==null||typeof e!="object")return!1;let t=Object.getPrototypeOf(e);return t!==null&&t!==Object.prototype&&Object.getPrototypeOf(t)!==null?!1:!(Symbol.iterator in e)&&!(Symbol.toStringTag in e)}function C(e){return typeof e=="string"}function Ge(e){return Number.isFinite(e)}function U(e){return typeof e=="boolean"}function P(e){return e!=null}function qe(e,t){return g(e)&&C(t)&&t in e}function ze(e,t){return e.localeCompare(t)}function v(e){return e==null?!1:Array.isArray(e)||typeof e=="string"?!!e.length:g(e)?!!Object.keys(e).length:typeof e=="number"}var Xe=ut(Je(),1);function J(e){if(typeof e!="string")throw new TypeError("Expected a string");return e.replace(/[|\\{}()[\]^$+*?.]/g,"\\$&").replace(/-/g,"\\x2d")}var Q=new Map,Qe=(e,t)=>{if(!Array.isArray(e))switch(typeof e){case"string":e=[e];break;case"undefined":e=[];break;default:throw new TypeError(`Expected '${t}' to be a string or an array, but got a type of '${typeof e}'`)}return e.filter(a=>{if(typeof a!="string"){if(typeof a>"u")return!1;throw new TypeError(`Expected '${t}' to be an array of strings, but found a type of '${typeof a}' in the array`)}return!0})},da=(e,t)=>{t=h({caseSensitive:!1},t);let a=e+JSON.stringify(t);if(Q.has(a))return Q.get(a);let r=e[0]==="!";r&&(e=e.slice(1)),e=J(e).replace(/\\\*/g,"[\\s\\S]*");let n=new RegExp(`^${e}$`,t.caseSensitive?"":"i");return n.negated=r,Q.set(a,n),n},ca=(e,t,a,r)=>{if(e=Qe(e,"inputs"),t=Qe(t,"patterns"),t.length===0)return[];t=t.map(o=>da(o,a));let{allPatterns:n}=a||{},f=[];for(let o of e){let s,u=[...t].fill(!1);for(let[l,c]of t.entries())if(c.test(o)&&(u[l]=!0,s=!c.negated,!s))break;if(!(s===!1||s===void 0&&t.some(l=>!l.negated)||n&&u.some((l,c)=>!l&&!t[c].negated))&&(f.push(o),r))break}return f};function G(e,t,a){return ca(e,t,a,!0).length>0}var ya={arrayVsArrayAllMustBeFound:"any",caseSensitive:!0};function H(e,t,a){if(!e.length||!t.length)return!1;let r=h(h({},ya),a),n=typeof e=="string"?[e]:Array.from(e);return typeof t=="string"?n.some(f=>G(f,t,{caseSensitive:r.caseSensitive})):r.arrayVsArrayAllMustBeFound==="any"?t.some(f=>n.some(o=>G(o,f,{caseSensitive:r.caseSensitive}))):t.every(f=>n.some(o=>G(o,f,{caseSensitive:r.caseSensitive})))}var p=(0,Xe.default)();var O=Array.isArray;function He(e){return!!e&&e.some(t=>typeof t=="string")}function xa(e,t){return Object.keys(e).length===0||Object.keys(t).length===0||Object.keys(e).every(a=>Object.keys(t).includes(a))||Object.keys(t).every(a=>Object.keys(e).includes(a))}function b(e){return e===null?"null":E(e)?"date":g(e)?"object":O(e)?"array":typeof e}var ba={cb:null,mergeObjectsOnlyWhenKeysetMatches:!0,ignoreKeys:[],hardMergeKeys:[],hardArrayConcatKeys:[],mergeArraysContainingStringsToBeEmpty:!1,oneToManyArrayObjectMerge:!1,hardMergeEverything:!1,hardArrayConcat:!1,ignoreEverything:!1,concatInsteadOfMerging:!0,dedupeStringsInArrayValues:!1,mergeBoolsUsingOrNotAnd:!0,useNullAsExplicitFalse:!1};function w(e,t,a,r){var c;let n;if(r.useNullAsExplicitFalse&&(t===null||a===null))return typeof r.cb=="function"?r.cb(t,a,null,{path:e.path,key:e.key,type:e.type}):null;let f=O(t)||g(t)?p(t):t,o=O(a)||g(a)?p(a):a,s;r.ignoreEverything?s=f:r.hardMergeEverything&&(s=o);let u=r.hardMergeEverything||r.ignoreEverything;if(O(f))if(v(f))if(O(o)&&v(o)){if(r.mergeArraysContainingStringsToBeEmpty&&(He(f)||He(o))){let i=u?s:[];return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:n,key:e.key,type:e.type}):i}if(r.hardArrayConcat){let i=u?s:f.concat(o);return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:n,key:e.key,type:e.type}):i}let m=[];for(let i=0,x=Math.max(f.length,o.length);i<x;i++)n=(c=e.path)!=null&&c.length?`${e.path}.${i}`:`${i}`,g(f[i])&&g(o[i])&&(r.mergeObjectsOnlyWhenKeysetMatches&&xa(f[i],o[i])||!r.mergeObjectsOnlyWhenKeysetMatches)?m.push(w({path:n,key:e.key,type:[b(f),b(o)]},f[i],o[i],r)):r.oneToManyArrayObjectMerge&&(f.length===1||o.length===1)?m.push(f.length===1?w({path:n,key:e.key,type:[b(f),b(o)]},f[0],o[i],r):w({path:n,key:e.key,type:[b(f),b(o)]},f[i],o[0],r)):r.concatInsteadOfMerging?(i<f.length&&m.push(f[i]),i<o.length&&m.push(o[i])):(i<f.length&&m.push(f[i]),i<o.length&&!_(f,o[i])&&m.push(o[i]));r.dedupeStringsInArrayValues&&m.every(i=>C(i))&&(m=[...new Set(m)].sort(ze)),f=p(m)}else{let m=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),m,{path:n,key:e.key,type:e.type}):m}else{if(v(o)){let i=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:n,key:e.key,type:e.type}):i}let m=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),m,{path:n,key:e.key,type:e.type}):m}else if(g(f)){if(v(f)){if(O(o)){if(v(o)){let d=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),d,{path:n,key:e.key,type:e.type}):d}let x=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),x,{path:n,key:e.key,type:e.type}):x}if(g(o)){Object.keys(o).forEach(d=>{var X;n=(X=e.path)!=null&&X.length?`${e.path}.${d}`:`${d}`,qe(f,d)?H(d,r.ignoreKeys)?f[d]=w({path:n,key:d,type:[b(f),b(o)]},f[d],o[d],F(h({},r),{ignoreEverything:!0})):H(d,r.hardMergeKeys)?f[d]=w({path:n,key:d,type:[b(f),b(o)]},f[d],o[d],F(h({},r),{hardMergeEverything:!0})):H(d,r.hardArrayConcatKeys)?f[d]=w({path:n,key:d,type:[b(f),b(o)]},f[d],o[d],F(h({},r),{hardArrayConcat:!0})):f[d]=w({path:n,key:d,type:[b(f[d]),b(o[d])]},f[d],o[d],r):f[d]=o[d]});let x=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),x,{path:e.path,key:e.key,type:e.type}):f}let i=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:e.path,key:e.key,type:e.type}):i}if(O(o)||g(o)||v(o)){let i=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:e.path,key:e.key,type:e.type}):i}let m=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),m,{path:e.path,key:e.key,type:e.type}):m}else if(E(f)){if(V(+f)){if(E(o)){if(V(+o)){let d=u?s:f>o?f:o;return typeof r.cb=="function"?r.cb(p(t),p(a),d,{path:e.path,key:e.key,type:e.type}):d}let x=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),x,{path:e.path,key:e.key,type:e.type}):x}let i=u?s:o||f;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:e.path,key:e.key,type:e.type}):i}if(E(o)){let i=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:e.path,key:e.key,type:e.type}):i}let m=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),m,{path:e.path,key:e.key,type:e.type}):m}else if(C(f)){if(v(f)){if((O(o)||g(o)||C(o))&&v(o)){let x=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),x,{path:e.path,key:e.key,type:e.type}):x}let i=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:e.path,key:e.key,type:e.type}):i}if(P(o)&&!U(o)){let i=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:e.path,key:e.key,type:e.type}):i}let m=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),m,{path:e.path,key:e.key,type:e.type}):m}else if(Ge(f)){if(v(o)){let i=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:e.path,key:e.key,type:e.type}):i}let m=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),m,{path:e.path,key:e.key,type:e.type}):m}else if(U(f)){if(U(o)){if(r.mergeBoolsUsingOrNotAnd){let x=u?s:f||o;return typeof r.cb=="function"?r.cb(p(t),p(a),x,{path:e.path,key:e.key,type:e.type}):x}let i=u?s:f&&o;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:e.path,key:e.key,type:e.type}):i}if(P(o)){let i=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:e.path,key:e.key,type:e.type}):i}let m=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),m,{path:e.path,key:e.key,type:e.type}):m}else if(f===null){if(P(o)){let i=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),i,{path:e.path,key:e.key,type:e.type}):i}let m=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),m,{path:e.path,key:e.key,type:e.type}):m}else{let m=u?s:o;return typeof r.cb=="function"?r.cb(p(t),p(a),m,{path:e.path,key:e.key,type:e.type}):m}let l=u?s:f;return typeof r.cb=="function"?r.cb(p(t),p(a),l,{path:e.path,key:e.key,type:e.type}):l}function Ze(e,t,a){var n,f;if(!arguments.length)throw new TypeError("object-merge-advanced/mergeAdvanced(): [THROW_ID_01] Both inputs are missing");if(P(a)&&!g(a))throw new TypeError(`object-merge-advanced/mergeAdvanced(): [THROW_ID_02] The optional options object should be a plain object, currently it's ${JSON.stringify(a,null,4)} (type ${typeof a})`);let r=h(h({},ba),a);return typeof r.ignoreKeys=="string"&&(r.ignoreKeys=[r.ignoreKeys]),typeof r.hardMergeKeys=="string"&&(r.hardMergeKeys=[r.hardMergeKeys]),(n=r==null?void 0:r.hardMergeKeys)!=null&&n.includes("*")&&(r.hardMergeEverything=!0),(f=r==null?void 0:r.ignoreKeys)!=null&&f.includes("*")&&(r.ignoreEverything=!0),w({key:null,path:"",type:[b(e),b(t)]},e,t,r)}var Ye="4.0.12";var ha=Ye,et={dedupe:!0};function Aa(e){return Object.keys(e).sort().reduce((t,a)=>(t[a]=e[a],t),{})}function ja(e,t){if(Array.isArray(e)){if(e.length===0)return{}}else throw new Error(`array-of-arrays-into-ast: [THROW_ID_01] inputArr must be array. Currently it's of a type ${typeof e} equal to:
${JSON.stringify(e,null,4)}`);let a=h(h({},et),t),r={};return e.forEach(n=>{let f=null;for(let o=n.length;o--;)f={[n[o]]:[f]};r=Ze(r,f,{concatInsteadOfMerging:!a.dedupe})}),Aa(r)}return lt(va);})();
/**
 * @name codsen-utils
 * @fileoverview Various utility functions
 * @version 1.5.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/codsen-utils/}
 */
/**
 * @name util-nonempty
 * @fileoverview Is the input (plain object, array, string or whatever) not empty?
 * @version 5.0.10
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/util-nonempty/}
 */
/**
 * @name object-merge-advanced
 * @fileoverview Deeply merge JSON-like data structures
 * @version 14.0.12
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/object-merge-advanced/}
 */
/*! Bundled license information:

lodash-es/lodash.js:
  (**
   * @license
   * Lodash (Custom Build) <https://lodash.com/>
   * Build: `lodash modularize exports="es" -o ./`
   * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
   * Released under MIT license <https://lodash.com/license>
   * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
   * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
   *)
*/
